# shortnews.tcl v1.2 by domsen <domsen@domsen.org> (c)2oo1
#
# comments? bugs? ideas? plz mail me :)
#
# liest die news von www.shoetnews.de aus und gibt
# sie wieder... auf abruf den passenden link und auf wunsch
# werden neue newslines geposted. siehe heise.tcl und meine
# anderen newsposter.
#
# usage:
#
# .shortnews - ruft die 'shortnewslimit' newslines ab
# .shortnewslink <nr> - sucht den passenden link zur newsline
# snlimit - "" fr unbegrenzt, ratsam ist ein wert von 10
# snnewspost - 1 fr newsposting an, 0 fr aus
# snchans - die channels in denen das tcl aktiv ist
# issnhub legt fest ob der bot newshub ist oder nicht, das
# leaf tcl ist auch auf www.domsen.org verfgbar.
#
# snleafs sind die nicks der leafbots auf denen das leaf tcl
# luft
#
# man htte dieses tcl auch simpler coden knnen durch den
# gebrauch von regusbs und wget, aber das wre zu einfach
# gewesen da man die regsub-strings aus den php backends
# benutzen knnte - wo bleibt da die herausforderung. wget
# ist auerdem nicht auf allen shells erlaubt, also habe ich
# mich fr lynx entschieden. die tcl http lib wollte ich auch
# nicht benutzen, da ich gerne auf fremden externen code
# vollkommen verzichte :-)
#
####### config ######################



set sntrigger ".shortnews"
set snsearchtrigger ".shortnewslink"
set snlimit 10
set hehe " "
set snchans ""
set snnewspost "0"
set snnewslimit "3"
set issnhub "1"
set snleafs ""

bind msg - $sntrigger msg_sn
bind pub - $sntrigger pub_sn
bind msg - $snsearchtrigger msg_snsearch
bind pub - $snsearchtrigger pub_snsearch
bind time - "?5 * * * *" sncheck
bind time - "?0 * * * *" sncheck

proc sendshortnewsnews { arg } {
global snleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $snleafs] [string tolower $bot]] != -1)} {
putbot $bot "shortnews: $arg"
}}}

proc sncheck { nick uhost hand chan arg } {
global snchans snnewspost snnewslimit issnhub
set hehe " "
set limita 0
set snhdlfile "sn.hdl"
set snoldnews "none"
if {$snnewspost == 1 } {
if {[file exists $snhdlfile]} {
putlog "shortnews: suche nach neuer newsline"
set counter 0
set temp2 [open "sn.hdl" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "die aktuellsten ShortNews zuerst!" $zeile] != "-1" } {
incr counter }
if { [string first "mehr ShortNews..." $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && ([string first "]" $zeile] != "-1") && ([string first "aktuellsten ShortNews zuerst" $zeile] == "-1") } {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
set snoldnews [string range $zeile 4 [string length $zeile]]
incr counter }
}
close $temp2 }
exec lynx -preparsed -dump http://www.shortnews.de/start.cfm?rubrik1=Alles&rubrik2=Alles&rubrik3=Alles&sort=3&sparte=4&zeitraum=1 > sn.hdl
set counter 0
if {$snoldnews == "none" } { 
putlog "shortnews: headlinefile created"
return 0 
}
set temp2 [open "sn.hdl" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "die aktuellsten ShortNews zuerst!" $zeile] != "-1" } {
incr counter }
if { [string first "mehr ShortNews..." $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && ([string first "]" $zeile] != "-1") && ([string first "aktuellsten ShortNews zuerst" $zeile] == "-1") } {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
set snnewnews [string range $zeile 4 [string length $zeile]]
if {$snoldnews == $snnewnews} { return 0 }
if {$snoldnews != $snnewnews} {
putlog "shortnews: neue newsline"
if { $issnhub == "1" } { sendshortnewsnews $snnewnews }
if {$limita == $snnewslimit } { return 0 }
incr limita 1
foreach chan [channels] {
if {$snchans == "" } { putserv "privmsg $chan :(neue shortnews.de newsline) $snnewnews" }
if {$snchans != "" } {
if {([lsearch -exact [string tolower $snchans] [string tolower $chan]] != -1) || ($snchans == "")} {
putserv "privmsg $chan :(neue shortnews.de newsline) $snnewnews"
}}}}}}
close $temp2
}






}









proc msg_snsearch {nick uhost hand arg } {
exec lynx -preparsed -dump http://www.shortnews.de/start.cfm?rubrik1=Alles&rubrik2=Alles&rubrik3=Alles&sort=3&sparte=4&zeitraum=1 > sn.temp
set newsline 0
set counter 0
set linknr ""
set temp2 [open "sn.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "die aktuellsten ShortNews zuerst!" $zeile] != "-1" } {
incr counter }
if { [string first "mehr ShortNews..." $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && ([string first "]" $zeile] != "-1") && ([string first "aktuellsten ShortNews zuerst" $zeile] == "-1") } {
incr newsline 
if {$newsline == $arg} {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.shortnews.de/start.cfm"
}}
if { ([string first $linknr $zeile] != -1) && ($linknr != "")} {
set snhyperlink [string range $zeile 6 [string length $zeile]]
putserv "privmsg $nick :$snhyperlink"
putlog "shortnews: link search by $nick"
return 0 }
}
close $temp2
}



proc pub_snsearch {nick uhost hand chan arg } {
global snchans
if {([lsearch -exact [string tolower $snchans] [string tolower $chan]] != -1) || ($snchans == "")} {
exec lynx -preparsed -dump http://www.shortnews.de/start.cfm?rubrik1=Alles&rubrik2=Alles&rubrik3=Alles&sort=3&sparte=4&zeitraum=1 > sn.temp
set newsline 0
set counter 0
set linknr ""
set temp2 [open "sn.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "die aktuellsten ShortNews zuerst!" $zeile] != "-1" } {
incr counter }
if { [string first "mehr ShortNews..." $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && ([string first "]" $zeile] != "-1") && ([string first "aktuellsten ShortNews zuerst" $zeile] == "-1") } {
incr newsline 
if {$newsline == $arg} {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://www.shortnews.de/start.cfm"
}}
if { ([string first $linknr $zeile] != -1) && ($linknr != "")} {
set snhyperlink [string range $zeile 6 [string length $zeile]]
putserv "notice $nick :$snhyperlink"
putlog "shortnews: link search by $nick"
return 0 }
}
close $temp2
}}









proc msg_sn { nick uhost hand arg } {
global snlimit hehe
exec lynx -preparsed -dump http://www.shortnews.de/start.cfm?rubrik1=Alles&rubrik2=Alles&rubrik3=Alles&sort=3&sparte=4&zeitraum=1 > sn.temp
if {($arg == "") && ($snlimit != "")} {
putlog "shortnews: sent last $snlimit newslines to $nick"
set counter 0
set newslinenr 0
set temp2 [open "sn.temp" r]
putserv "privmsg $nick :heutige shortnews.de news"
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "die aktuellsten ShortNews zuerst!" $zeile] != "-1" } {
incr counter }
if { [string first "mehr ShortNews..." $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1" && ([string first "aktuellsten ShortNews zuerst" $zeile] == "-1")} {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
set news [string range $zeile 4 [string length $zeile]]
if {$newslinenr < $snlimit } {
incr newslinenr 
putserv "privmsg $nick :$newslinenr $news"
}}}
close $temp2
}
if {($arg == "all") || ($snlimit == "")} {
putlog "shortnews: sent all newslines to $nick"
set counter 0
set newslinenr 0
set temp2 [open "sn.temp" r]
putserv "privmsg $nick :heutige shortnews.de news"
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "die aktuellsten ShortNews zuerst!" $zeile] != "-1" } {
incr counter }
if { [string first "mehr ShortNews..." $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1" && ([string first "aktuellsten ShortNews zuerst" $zeile] == "-1")} {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
set news [string range $zeile 4 [string length $zeile]]
incr newslinenr 
putserv "privmsg $nick :$newslinenr $news"
}}
close $temp2
}}


proc pub_sn { nick uhost hand chan arg } {
global snlimit hehe snchans
if {([lsearch -exact [string tolower $snchans] [string tolower $chan]] != -1) || ($snchans == "")} {
exec lynx -preparsed -dump http://www.shortnews.de/start.cfm?rubrik1=Alles&rubrik2=Alles&rubrik3=Alles&sort=3&sparte=4&zeitraum=1 > sn.temp
if {($arg == "") && ($snlimit != "")} {
putlog "shortnews: sent last $snlimit newslines to $nick"
set counter 0
set newslinenr 0
set temp2 [open "sn.temp" r]
putserv "notice $nick :heutige shortnews.de news"
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "die aktuellsten ShortNews zuerst!" $zeile] != "-1" } {
incr counter }
if { [string first "mehr ShortNews..." $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1" && ([string first "aktuellsten ShortNews zuerst" $zeile] == "-1")} {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
set news [string range $zeile 4 [string length $zeile]]
if {$newslinenr < $snlimit } {
incr newslinenr 
putserv "notice $nick :$newslinenr $news"
}}}
close $temp2
}
if {($arg == "all") || ($snlimit == "")} {
putlog "shortnews: sent all newslines to $nick"
set counter 0
set newslinenr 0
set temp2 [open "sn.temp" r]
putserv "notice $nick :heutige shortnews.de news"
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first "die aktuellsten ShortNews zuerst!" $zeile] != "-1" } {
incr counter }
if { [string first "mehr ShortNews..." $zeile] != "-1" } {
incr counter }
if { ($counter == "1") && ($zeile != "") && [string first "]" $zeile] != "-1" && ([string first "aktuellsten ShortNews zuerst" $zeile] == "-1")} {
while {[string first $hehe $zeile ] == "0"} { set zeile [string range $zeile 1 [string length $zeile]]}
set news [string range $zeile 4 [string length $zeile]]
incr newslinenr 
putserv "notice $nick :$newslinenr $news"
}}
close $temp2
}}}

putlog "*** shortnews.tcl v1.o by domsen succesfully loaded"

# [EOF]